"use strict";
/**
 * @module github
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const octokit = require('@octokit/rest')();
const rpscript_interface_1 = require("rpscript-interface");
let RPSGithub = class RPSGithub {
    getForOrg(ctx, opts, organization, type) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise(function (resolve, reject) {
                octokit.repos.getForOrg({ org: organization, type: type })
                    .then(({ data, headers, status }) => resolve(data)).catch(err => reject(err));
            });
        });
    }
    getForUser(ctx, opts, username) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise(function (resolve, reject) {
                octokit.repos.getForUser({ username: username })
                    .then(({ data, headers, status }) => resolve(data)).catch(err => reject(err));
            });
        });
    }
};
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'github-get-for-organization' })
], RPSGithub.prototype, "getForOrg", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'github-get-for-user' })
], RPSGithub.prototype, "getForUser", null);
RPSGithub = __decorate([
    rpscript_interface_1.RpsModule("github")
], RPSGithub);
exports.default = RPSGithub;
